from libmarbles import *

def bit2dir(number, bit):
    return RIGHT if number & (1 << bit) else LEFT

A = 2
B = 3

board = Board()
# A bits
board.place_cell((0, 0), Bit(bit2dir(A, 0)))
board.place_cell((2, 0), Bit(bit2dir(A, 1)))
board.place_cell((4, 0), Bit(bit2dir(A, 2)))

# B bits
# after execution, these will have bits for A+B
board.place_cell((0, 4), Bit(bit2dir(B, 0)))
board.place_cell((2, 4), Bit(bit2dir(B, 1)))
board.place_cell((4, 4), Bit(bit2dir(B, 2)))

# set up the A bits to do decrement: start from the LSB and flip until you hit
# something that was set to 1. at that point, drop a marble on the B bits.

B_marble = Marble((0, 4), LEFT, RED)

# bit 0 false/true
board.place_cell((1, -1), Ramp(RIGHT))
board.place_cell((1, +1), DropTrigger(B_marble))
# bit 1 false/true
board.place_cell((3, -1), Ramp(RIGHT))
board.place_cell((3, +1), DropTrigger(B_marble))
# bit 2 false/true
board.place_cell((5, -1), Interceptor()) # underflow; stop!
board.place_cell((5, +1), DropTrigger(B_marble))

# set up the B bits to do increment: start from the LSB and flip until you hit
# something that was set to 0. at that point, drop a marble on the A bits.

A_marble = Marble((0, 0), LEFT, BLUE)

# bit 0 false/true
board.place_cell((1, 3), DropTrigger(A_marble))
board.place_cell((1, 5), Ramp(LEFT))
# bit 1 false/true
board.place_cell((3, 3), DropTrigger(A_marble))
board.place_cell((3, 5), Ramp(LEFT))
# bit 2 false/true
board.place_cell((5, 3), DropTrigger(A_marble))
board.place_cell((5, 5), DropTrigger(A_marble))

board.marble = Marble((0, 0), LEFT, BLUE)

end_board = board.interactive(auto_stop=True)

# now read the sum out ...
def bits2num(bits):
    if not bits: return 0
    lsb = 0 if bits[0].direction == LEFT else 1
    return lsb | (bits2num(bits[1:]) << 1)

print(bits2num([end_board.cells[(0, 4)],
                end_board.cells[(2, 4)],
                end_board.cells[(4, 4)]]))
